;This program is in the Public Domain
;Use build.bat to build or do "asm menu.asm menu.obj nul.lst nul.crf"
;"tlink /t menu.obj"

;INT 33 might be uninitialized on old machines, so the caller should first check that INT 33 is neither 0000h:0000h nor points at an IRET instruction (BYTE CFh) before calling this API
;Bugs - 
;If one clicks on a 'bad' menu entry, and then clicks on a good one, the good one ceases to work.
;Todo - 
;Check for the required CPU and mouse and color screen
;Use BIOS for clock instead of CMOS
;Parse COMSPEC and PATH
;Wishlist - 
;Ability to use keyboard
;Ability to use a menu option after timeout, if in menu.dat
dat     segment ; MENU.asm (Bedienung: Menu DATEI)
        org  100h
        assume  cs:dat,ds:dat,es:dat
; Dateiformat: 12*
; [Text2*19[Programmname[* Parameter|?Parameterfrage]]]]CR[LF]
; Aufruf MENU[ |/][DATEINAME]

; Version 1.2.95 nchste nderung 19.4.95 =>
; M_SAGE vor EXEC und AX=3, INT 10 nach EXEC

;***************************************************************************
code    PROC    ; Menuexec + Rahmtest als Quelle => MEHR daraus 28.1.94
        call RESTDRV
        call LOAD
        call CLS
        call MAUSAN
        call TITEL
        call MAKBILD
        call SHOWMENU
        call MAUS
        call MAUSAUS
        call CLS
        test word ptr wahl,0fff0h
        jnz ente
        call SAVEDRV
        jmp EXEC
ente:   mov ax,4ceah    ; EA als Code: habe ein Menu verlassen (4/1995)
        int 21h
code    ENDP
;***************************************************************************
load    PROC
        mov bx,ds:[80h] ; ds:!
        xor bh,bh
        cmp bl,2
        jb l_l
        mov byte ptr [81h+bx],0
        mov dx,82h
        mov ax,3d00h    ; Openforread
        int 21h
        jc l_l
        mov bx,ax       ; Handle
        mov dx,offset test1
        mov cx,3000     ; 2400 reichen fr 12*200
        mov ah,3fh      ; Read
        int 21h
        ; hier wahre Lnge in REG
        mov ah,3eh      ; Close
        int 21h
l_l:    RET
load    ENDP
;***************************************************************************
drv     PROC
savedrv:
        mov ah,19h
        int 21h
        mov curdrv,al
        RET
restdrv:
        mov ah,0eh
        mov dl,curdrv
        cmp dl,255
        jz norest
        int 21h
norest: RET
drv     ENDP
;***************************************************************************
titel   PROC
        mov dx,256*24+0
        mov si,offset tit
        mov ch,21h      ; B auf G
        call strtit
        mov dx,256*24+20
        mov si,offset tit2
        cmp byte ptr cs:[81h],' '
        jnz etit        ; CR => eigentlich 'End with ESC!' nicht getestet
        mov ch,1fh      ; W auf B
        call strtit
etit:   RET
strtit: lodsb
        or al,al
        jz estr
        mov ah,ch
        call PUT
        inc dl
        jmp short strtit
estr:   RET
tit     db 'AuerSoft MAUSMENU ',0
tit2    db 'ESC to leave',0
titel   ENDP
;***************************************************************************
uhr     PROC
        mov dx,24*256+40
        ; Int 21.2a / 1a.4 date dl.dh.cx
        ; Int 21.2c / 1a.2 time  ch:cl:dh
        mov ax,6
        call CMOS
        mov bx,ax
        add bx,bx
        mov ax,tage[bx]
        call PUTINC
        xchg al,ah
        call PUTINC
        mov al,','
        call PUTINC
        mov ax,256*'.'+7
        call BCD
        mov ax,256*'.'+8
        call BCD
        mov ax,2009h
        call BCD
        MOV dl,60
        mov ax,256*':'+4
        call BCD
        mov ax,256*':'+2
        call BCD
        mov ax,256*' '+0
        call BCD
        RET
putinc:
        push ax
        mov ah,1ah      ; Grn
        call PUT
        inc dl
        pop ax
        RET
cmos:
        out 70h,al
        jmp $+2
        in al,71h
        RET
bcd:
        call CMOS
        mov cx,ax
        xor ah,ah
        mov cl,10H
        div cl
        add ax,'00'
        call PUTINC
        xchg al,ah
        call PUTINC
        mov al,ch
        call PUTINC
        RET
tage    dw 'oS','oM','iD','iM','oD','rF','aS'
uhr     ENDP
;***************************************************************************
makbild PROC
        mov ax,0
m_k:    push ax
        call CALCPOS
        mov bl,breit
        mov bh,hoch
        sub bx,0102h
        mov ah,1ch      ; Farbe
        clc     ; Delta
        call RAHM
        pop ax
        inc ax
        cmp ax,12
        jb m_k
        RET
makbild ENDP
;***************************************************************************
maus    PROC
m_an:   call UHR
        mov ah,1
        int 16h
        jz noesc
        cmp al,27                       ; ax,11bh
        jnz noesc2
        cmp byte ptr ds:[81h],' '       ; menu/datei => ESC-Sperre
        jz okesc
        cmp byte ptr ds:[81h],13        ; kein Parameter => FREI
        jnz noesc2
okesc:  mov ah,0
        int 16h
okesc2: mov word ptr wahl,0ffffh
        RET
noesc2: mov ah,0
        int 16h
noesc:  mov ax,3        ; Get Pos
        int 33h
        and bx,7
        jz m_an
                cmp bl,4        ; ...> neu 4/1995
                jnz m_aus
m2aus:          mov ax,3
                int 33h
                test bx,7
                jnz m2aus
                cmp byte ptr ds:[81h],' '
                jz okesc2       ; mit Parameter, kein '/',Maus-Escape ok ...<
m2an:   jmp short m_an
m_aus:  mov ax,3        ; Get Pos (CX,DX,BX)
        int 33h
        test bx,7
        jnz m_aus       ; erwarte Loslassen
         mov ax,cx
         mov cl,3       ; Grafikpos fr 8*8
         shr ax,cl
         shr dx,cl
         mov cx,ax
        sub cl,lioben
        jc m_an
        sub dl,obenli
        jc m_an
        mov ax,cx
        div breit
        add ah,2
        cmp ah,breit
        jnb m_an
        mov cl,al
        mov ax,dx
        div hoch
        inc ah
        cmp ah,hoch
        jnb m2an
        mov dl,3
        mul dl
        add al,cl
        cmp al,12
        jnb M2AN
         push ax
         call CALCPOS
         mov bl,breit
         mov bh,hoch
         sub bx,0102h
         mov ah,1fh      ; Farbe
         clc     ; Delta
         call RAHM
         pop ax
        mov wahl,ax
        RET
wahl    dw 0    ; Programmwahl
maus    ENDP
;***************************************************************************
calcpos PROC    ; ax => dl!dh
        push ax
        and ax,15
        mov dl,3
        div dl
        mov dl,ah
        push ax
        mov al,breit
        mul dl
        mov dl,al
        pop ax
        mul hoch
        add al,obenli
        mov dh,al
        add dl,lioben
        pop ax
        RET
calcpos ENDP
lioben  db 5    ; 1. Pos L
obenli  db 2    ; 1. Pos Y
breit   db 23
hoch    db 5
brtext  equ 19
;***************************************************************************
mausan  PROC
        mov ax,0        ; Init
        int 33h
        mov ax,1        ; Zeiger An
        int 33h
        mov ax,0ah      ; Zeiger Form
        mov bx,0        ; nicht Block, Char
        mov dx,2400h    ; XOR
        mov cx,00ffh    ; AND
        int 33h
        mov ax,4        ; Set Pos
        xor cx,cx
        xor dx,dx
        int 33h
        mov ax,1dh      ; Set Page
        xor bx,bx
        int 33h
m_a:    mov ax,3        ; Get Pos cx dx Key bx
        int 33h
        test bx,7
        jnz m_a
        RET
mausan  ENDP
;***************************************************************************
mausaus PROC
        push ax
        mov ax,2        ; Zeiger aus
        int 33h
        pop ax
        RET
mausaus ENDP
;***************************************************************************
rahm    PROC    ; Rahmen (dl/dh) (bl/bh), STC => b..=Punkt CLC => b..=Delta..
                ; !! keine Fehlerprfung !!     Farbe ah
        push ax
        push cx
        push bx
        jnc no_re
re:     sub bx,dx
no_re:
        xor cx,cx

        mov cl,bl       ; d_x
        dec cx
        dec cx
        mov al,''
        call PUT
        inc dx  ; dl
        mov al,''
ei:      call PUT
         inc dx  ; dl
         loop ei
        mov al,''
        call PUT

        inc dh
        mov cl,bh       ; d_y
        dec cx
        dec cx
        mov al,''
zw:      call PUT
         inc dh
         loop zw

        mov al,''
        call PUT
        dec dx  ; dl
        mov cl,bl       ; d_x
        dec cx
        dec cx
        mov al,''
dr:      call PUT
         dec dx ; dl
         loop dr
        mov al,''
        call PUT
        dec dh

        mov cl,bh       ; d_y
        dec cx
        dec cx
        mov al,''
vi:      call PUT
         dec dh
         loop vi

        pop bx
        pop cx
        pop ax
        RET
rahm    ENDP
;***************************************************************************
put     PROC    ; AL,   Farbe AH => Pos dl/dh
        push bx
        push ds
        push ax
        mov al,2*80
        mul dh
        mov bx,dx
        shl bx,1        ; dl
        xor bh,bh
        add bx,ax
         mov ax,0b800h
         mov ds,ax
        pop ax
        mov ds:[bx],ax
        pop ds
        pop bx
        RET
put     ENDP
;***************************************************************************
cls     PROC
        push es
        push ax
        push di
        push cx

        mov ax,0b800h
        mov es,ax       ; ZIEL IST EXTRASEGMENT
        mov ax,1e20h    ; Blaugelbes Space
        mov cx,80*25    ; 2000
        xor di,di
        cld
        REP STOSW

        mov ah,2        ; Set Pos
        xor dx,dx
        mov bh,0
        int 10h

        pop cx
        pop di
        pop ax
        pop es
        RET
cls     ENDP
;***************************************************************************
show    PROC
showmenu:
        xor ax,ax
sw:     mov si,offset test1
        push ax
        call CALCPOS
        add dx,0101h
         push dx
         push ax
        call FIND
         pop ax
         pop dx
        jc sn
        call DISP2
        pop ax
        jnc oksn
        push ax
        call CALCPOS
        mov bl,breit
        mov bh,hoch
        sub bx,0102h
        mov ah,11h      ; unsichtbar
        clc     ; Delta
        call RAHM
        pop ax
oksn:   inc ax
        cmp ax,12
        jb sw
        RET
sn:     pop ax
        RET
nixi:
        stc
        RET
disp2:
        push si
        mov cx,2*brtext
ci:     lodsb
        call EOF
        loopnz ci
        or cx,cx
        pop si
        jnz nixi
        mov cl,2*brtext
dxi:    lodsb
        mov ah,1eh      ; Farbe Text
        call PUT
        inc dl
        cmp cl,brtext+1
        jnz d_i
        sub dl,brtext
        inc dh
d_i:    loop dxi
        clc
        RET

show    ENDP
;***************************************************************************
exec    PROC
        mov inf[4],cs   ; da kein EXE von HAND
        call INST       ; Ram kleiner, alter Stack futsch
        mov ax,wahl     ; Auswahl
        and ax,0fh
        mov si,offset test1
        call FIND
        jc xxx
        call DISP       ; als Pseudo erhalten ! (Text berspringen)
        jc bye2
        call GFIL
        jc bye2
        call CHDIR      ; neu ArbeitsVERZEICHNIS setzen
        jc xxx
        call PARM
        ; jc kein_parameter (weder * noch ?)
                call M_SAGE     ; neu 4/95
        call EXECUT
        jnc bye
xxx:    mov al,7
        call TTY
        jmp short bye2
bye:    cmp al,0eah     ; ...>
        jz bye2
        call MAUSAN
byye:   mov ax,3
        int 33h         ; MAUS-Taste... neu 1995
        test bx,7
        jz byye
        call MAUSAUS    ; ...<
bye2:   mov ax,3
        int 10h
        jmp CODE

m_sage:         ; neu 1995
        db 60h          ; pusha
        mov cx,1
;        call seconds
        call CLS
        mov si,offset bbye ; dos: dx (Int 21.9, crlf$ in String tun)
        mov dx,0c0dh    ; Position (dl=x dh=y)
        mov ch,1ch      ; Farbe
        call STRTIT     ; gegen ^C
        mov cx,1
;        call seconds
        call CLS
        db 61h          ; popa
        RET
seconds:        ; neu 1995
        and cx,1fh
        inc cx
eizwse: xor ax,ax
        call CMOS
        mov dl,al
ezs:    mov al,ah
        call CMOS
        cmp al,dl
        jz ezs
        loop eizwse
        RET

inst:
         pop bp
        mov bx,offset test1[3000]       ;sta ;Mendatei meist 1k, max 3.5k
        and bx,0fffeh
        add bx,128
        cli
        mov sp,bx       ; Stack anpassen
        sti
        mov cl,4
        shr bx,cl
        inc bx
        mov ah,4ah      ; ndere Grsse
        int 21h
         push bp
        RET
find:
        INC AX
        cld
        dec ax
        jz ok
        mov cx,ax
b:      lodsb
        call EOF
        jnz b
        call EEF
        jz nix
         cmp byte ptr [si],10
         jz b
        loop b
ok:     clc
        RET
nix:    stc
        RET
disp:
        push si
        mov cx,2*brtext
c:      lodsb
        call EOF
        loopnz c
        or cx,cx
        pop si
        jnz nix
        add si,2*brtext
        clc
        RET
gfil:
        mov di,offset fil
        mov byte ptr [di],0
        mov cx,64
e:      lodsb
        call E_F
        jz gg           ; keins geht auch !
        stosb
        loop e
gg:     cmp cx,64
        jz nix
        mov ah,al
        xor al,al
        stosb
        RET
CHDIR:
        push si
        push ax
        mov ax,filw
        xor ah,':'
        jnz nowech
        mov dl,al
        and dl,1fh
        cmp dl,24       ; ab X ignorieren
        jnb nowech
        DEC dl          ; a: = 0
        mov ah,0eh
        INT 21h         ; Change Drive
nowech: mov di,offset fil
        xor al,al
        mov cx,64
        repnz scasb     ; 0 suchen
        std
        mov al,'\'
        mov ah,cl
        mov cx,64
        sub cl,ah
        repnz scasb     ; letztes \ suchen
        INC di
        cld
        cmp byte ptr ds:[di],'\'
        clc
        jnz nchdir
        mov ds:[di],ch  ; 0
        mov dx,offset fil
        mov ah,3bh
        INT 21h         ; Change Dir
        mov byte ptr ds:[di],'\'
nchdir: pop ax
        pop si
        RET
parm:
        mov di,offset par
        mov [di],al
        inc di
        xor cl,cl
        cmp ah,'?'
        jz inp
        cmp ah,'*'
        jnz pp  ; nix => wrde Abfrage erlauben
pme:    lodsb
        call EOF
        jz pp
        inc cl
        cmp cl,126
        ja pp
        stosb
        jmp short pme
pp:     mov par[0],cl
        mov al,13
        stosb
        RET
inp:    lodsb
        call EOF
        jz ii
        call TTY
        jmp short inp
ii:     mov dx,offset gpar
        mov ah,10       ;getstring
        int 21h
        RET
execut:
        db 60h  ; PUSHA
        push ds
        push es
        mov s_ptr,sp
        mov s_ptr[2],ss
         mov dx,offset fil
         mov bx,offset inf
         mov ax,4b00h
         int 21h
        cli
        mov sp,cs:s_ptr
        mov ss,cs:s_ptr[2]
        sti
        pop es
        pop ds
        db 61h  ; POPA
        jnc xx
        RET     ; Error
xx:     mov ah,4dh
        int 21h ; Get EndCode
        RET

e_f:    cmp al,'*'
        jz ee
        cmp al,'?'
        jz ee
eof:    cmp al,10
        jz ee
        cmp al,13
        jz ee
eef:    cmp al,26
        jz ee
        or al,0
ee:     RET
tty:
        push ax
        mov ah,14
        mov bx,1eh
        int 10h
        pop ax
        RET
crlf:
        push ax
        push bx
        mov al,13
        call TTY
        mov al,10
        call TTY
        pop bx
        pop ax
        RET
exec    ENDP
;***************************************************************************
curdrv  db 255  ; nix
curdir  db 'c:\dos',0,57 dup(0) ; z.Zt. ungenutzt
filw    dw ?
org $-2
fil     db 65 dup(0)
gpar    db 127  ; Forts. in par
par     db 0,128 dup(0)
inf     dw 0    ; ENV-Seg
        dw offset par,? ; CS hierher
        dw 0,0          ; FCB 1
        dw 0,0          ; FCB 2
s_ptr   dw ?,?
bbye db 'Press a mouse button to return!!! ',0 ; 13,10,'$'
           ;12345678901234567891234567890123456789test.com?WasCR (kein TAB)
test1   db 13,10                                ;v;
test2   db 'This program is in the public domain. ',13,10
test3   db 13,10
test4   db 13,10
test5   db '    Exit to DOS                       c:\command.com',13,10
test6   db 13,10
test7   db 13,10
test8   db '12345678901234567891234567890123456789',13,10
test9   db 13,10
test10  db 13,10
test11  db 'You can do whatever with this program.',13,10
test12  db 26
sta     db '(c) AuerSoft '
;***************************************************************************
dat     ENDS
END     CODE
